Index: /pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- /pjproject/trunk/pjmedia/build/Makefile	(revision 170)
+++ /pjproject/trunk/pjmedia/build/Makefile	(revision 171)
@@ -13,5 +13,6 @@
 export _CFLAGS 	:= $(CC_CFLAGS) $(OS_CFLAGS) $(HOST_CFLAGS) $(M_CFLAGS) \
 		   $(CFLAGS) $(CC_INC)../include $(CC_INC)../../pjlib/include \
-		   $(CC_INC)../../pjlib-util/include
+		   $(CC_INC)../../pjlib-util/include \
+		   $(CC_INC)../src/pjmedia/portaudio
 export _CXXFLAGS:= $(_CFLAGS) $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
 		   $(HOST_CXXFLAGS) $(CXXFLAGS)
@@ -28,16 +29,16 @@
 export PJMEDIA_SRCDIR = ../src/pjmedia
 export PJMEDIA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-			codec.o errno.o g711.o jbuf.o mediamgr.o rtcp.o \
-			rtp.o sdp.o sdp_cmp.o sdp_neg.o stream.o \
-#			pasound.o \
-#		      	$(PA_DIR)/pa_allocation.o \
-#			$(PA_DIR)/pa_converters.o \
-#			$(PA_DIR)/pa_cpuload.o \
-#			$(PA_DIR)/pa_dither.o \
-#			$(PA_DIR)/pa_front.o \
-#			$(PA_DIR)/pa_process.o \
-#			$(PA_DIR)/pa_skeleton.o \
-#			$(PA_DIR)/pa_stream.o \
-#			$(PA_DIR)/pa_trace.o
+			codec.o endpoint.o errno.o g711.o jbuf.o rtcp.o \
+			rtp.o sdp.o sdp_cmp.o sdp_neg.o session.o stream.o \
+			pasound.o \
+		      	$(PA_DIR)/pa_allocation.o \
+			$(PA_DIR)/pa_converters.o \
+			$(PA_DIR)/pa_cpuload.o \
+			$(PA_DIR)/pa_dither.o \
+			$(PA_DIR)/pa_front.o \
+			$(PA_DIR)/pa_process.o \
+			$(PA_DIR)/pa_skeleton.o \
+			$(PA_DIR)/pa_stream.o \
+			$(PA_DIR)/pa_trace.o
 
 export PJMEDIA_CFLAGS += $(_CFLAGS)
@@ -60,5 +61,6 @@
 # $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
 #
-TARGETS := pjmedia pjmedia-test
+TARGETS := pjmedia 
+#pjmedia-test
 
 all: $(TARGETS)
Index: /pjproject/trunk/pjmedia/build/os-win32.mak
===================================================================
--- /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 171)
+++ /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 171)
@@ -0,0 +1,13 @@
+#
+# OS specific configuration for Win32 OS target. 
+#
+
+#
+# PJMEDIA_OBJS specified here are object files to be included in PJMEDIA
+# (the library) for this specific operating system. Object files common 
+# to all operating systems should go in Makefile instead.
+#
+export PJMEDIA_OBJS += $(PA_DIR)/pa_win_hostapis.o $(PA_DIR)/pa_win_util.o \
+		       $(PA_DIR)/pa_win_ds.o
+
+export OS_CFLAGS += -DPA_NO_ASIO
Index: /pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 170)
+++ /pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 171)
@@ -339,10 +339,10 @@
  * Codec manager maintains codec factory etc.
  */
-typedef struct pjmedia_codec_mgr
+struct pjmedia_codec_mgr
 {
     pjmedia_codec_factory   factory_list;
     unsigned		    codec_cnt;
     pjmedia_codec_info	    codecs[PJMEDIA_CODEC_MGR_MAX_CODECS];
-} pjmedia_codec_mgr;
+};
 
 
Index: /pjproject/trunk/pjsip/build/Makefile
===================================================================
--- /pjproject/trunk/pjsip/build/Makefile	(revision 170)
+++ /pjproject/trunk/pjsip/build/Makefile	(revision 171)
@@ -55,5 +55,5 @@
 export PJSUA_SRCDIR = ../src/pjsua
 export PJSUA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-			main.o pjsua_reg.o pjsua_core.o
+			main.o pjsua_reg.o pjsua_inv.o pjsua_core.o
 export PJSUA_CFLAGS += $(_CFLAGS)
 export PJSUA_LDFLAGS += $(_LDFLAGS)
Index: /pjproject/trunk/pjsip/include/pjsip/sip_types.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 170)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 171)
@@ -137,5 +137,5 @@
  * Dialog state (sip_dialog.h).
  */
-enum pjsip_dialog_state pjsip_dialog_state;
+typedef enum pjsip_dialog_state pjsip_dialog_state;
 
 /**
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 170)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 171)
@@ -1579,4 +1579,6 @@
 	    break;
 
+	default:
+	    break;
 	}
     }
Index: /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 170)
+++ /pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 171)
@@ -562,7 +562,7 @@
 	    len = pj_snprintf(contact, sizeof(contact),
 			      "<sip:%.*s@%.*s:%d>",
-			      sip_uri->user.slen,
+			      (int)sip_uri->user.slen,
 			      sip_uri->user.ptr,
-			      udp_transport->local_name.host.slen,
+			      (int)udp_transport->local_name.host.slen,
 			      udp_transport->local_name.host.ptr,
 			      udp_transport->local_name.port);
@@ -573,5 +573,5 @@
 	    len = pj_snprintf(contact, sizeof(contact),
 			      "<sip:%.*s:%d>",
-			      udp_transport->local_name.host.slen,
+			      (int)udp_transport->local_name.host.slen,
 			      udp_transport->local_name.host.ptr,
 			      udp_transport->local_name.port);